using System ;
using System.Collections.Generic ;
using System.Runtime.InteropServices ;
using System.Text ;


namespace DxLibDLL
{


	public static partial class DX
	{


		public sealed class MovieToOverlay : Handler< MovieToOverlay >
		{

			internal static MovieToOverlay FromHandle( int handle )
			{
				MovieToOverlay handler = FindHandler( handle ) ;

				if( handler != null )
				{
					return handler ;
				}
				else
				{
					handler = new MovieToOverlay( handle ) ;
					AddHandler( handle, handler ) ;
					return handler ;
				}
			}

			private MovieToOverlay( int handle ) : base( handle )
			{
			}

			internal protected override sealed void DestructHandler( int handle )
			{
				lock( DX.locker )
				{
					int result = dx_CloseMovieToOverlay( handle ) ;
				}
			}

			/// <summary> オーバーレイサーフェスを使用したムービーファイルを閉じる </summary>
		#if UNICODE
			[ DllImport( "DxLibW.dll" , CharSet = CharSet.Unicode , ExactSpelling = true ) ]
		#else
			[ DllImport( "DxLib.dll" , CharSet = CharSet.Ansi , ExactSpelling = true ) ]
		#endif
			private static extern int dx_CloseMovieToOverlay( int MovieHandle ) ;
		}

		/// <summary> オーバーレイサーフェスを使用したムービーファイルを閉じる </summary>
		public static void CloseMovieToOverlay( MovieToOverlay MovieHandle )
		{
			Disposable.Dispose( MovieHandle ) ;
		}
	}
}
